!------------------------------------------------------------------------------
!      ()        
!              
!      ..  v1.0  15.09.98 (  CW4b(Gold)
!------------------------------------------------------------------------------
  MEMBER()

_VSDllMode_  EQUATE(0)
_VSLinkMode_ EQUATE(1)

  INCLUDE('grafboxd.Clw')

  MAP
  END


!----------------------------------------------------------------------------------------
!                    
!----------------------------------------------------------------------------------------
SCALEGraf.SetupScale PROCEDURE(SHORT XX1, SHORT YY1,SHORT XX2,SHORT YY2,BYTE DrawBoxBox, <*REAL[] MasX>,<*REAL[] MasY>)

SA       SHORT     ! 
LOC:I    SHORT
LOC:Om1  BYTE
LOC:Om2  BYTE

 CODE
 LOC:Om1 = OMITTED(7)
 LOC:Om2 = OMITTED(8)
 SELF.X1 = XX1; SELF.Y1 = YY1; SELF.X2 = XX1 + XX2; SELF.Y2 = YY1 + YY2

 SA = Maximum(MasY,1)                     !   
 IF LOC:Om1 AND LOC:Om2
   SELF.XMIN = -1000
   SELF.XMAX = 1000
   SELF.YMIN = -1000
   SELF.YMAX = 1000
 ELSE
   IF LOC:Om1
     SELF.XMIN = 0
     SELF.XMAX = SA
     SELF.YMIN = 0
   ELSE
     SELF.XMIN = MasX[1]
     SELF.XMAX = MasX[1]
     SELF.YMIN = MasY[1]
   .
   SELF.YMAX = MasY[1]
   LOOP LOC:I = 1 TO SA
      IF ~LOC:Om1
        IF SELF.XMIN > MasX[LOC:I] ; SELF.XMIN = MasX[LOC:I] .
        IF SELF.XMAX < MasX[LOC:I] ; SELF.XMAX = MasX[LOC:I] .
        IF SELF.YMIN > MasY[LOC:I] ; SELF.YMIN = MasY[LOC:I] .
      .
      IF SELF.YMAX < MasY[LOC:I] ; SELF.YMAX = MasY[LOC:I] .
   .
 .

! SELF.XMIN = XXMIN; SELF.YMIN = YYMIN; SELF.XMAX = XXMAX; SELF.YMAX = YYMAX

 SELF.XSPREAD = SELF.XMAX - SELF.XMIN
 SELF.YSPREAD = SELF.YMAX - SELF.YMIN

 SELF.XNORMRATIO = (SELF.X2 - SELF.X1) / SELF.XSPREAD
 SELF.YNORMRATIO = (SELF.Y2 - SELF.Y1) / SELF.YSPREAD

 IF DrawBoxBox ; BOX(XX1,YY1,XX2,YY2) .

!----------------------------------------------------------------------------------------
!                   X
!----------------------------------------------------------------------------------------
SCALEGraf.GETX FUNCTION(REAL X)
 CODE
 RETURN (X - SELF.XMIN)*SELF.XNORMRATIO

!----------------------------------------------------------------------------------------
!                   Y
!----------------------------------------------------------------------------------------
SCALEGraf.GETY FUNCTION(REAL Y)
 CODE
 RETURN (SELF.YMAX - Y)*SELF.YNORMRATIO

!----------------------------------------------------------------------------------------
!   : ,  , ...
!----------------------------------------------------------------------------------------
SCALEGraf.COUNTBOX PROCEDURE(REAL X1,REAL Y1,REAL X2,REAL Y2)
 CODE
      SELF.X = SELF.GETX(X1) + SELF.X1
      SELF.Y = SELF.GETY(Y1) + SELF.Y1
      SELF.W = SELF.GETX(X2) - SELF.X + SELF.X1
      SELF.H = SELF.GETY(Y2) - SELF.Y + SELF.Y1

!----------------------------------------------------------------------------------------
!                  
!----------------------------------------------------------------------------------------
SCALEGraf.PNT PROCEDURE(REAL X,REAL Y, REAL SX, REAL SY)
X1 REAL
Y1 REAL
X2 REAL
Y2 REAL

 CODE
       X1 = X-SX/2 ; X2 = X+SX/2 ;
       Y1 = Y-SY/2 ; Y2 = Y+SY/2 ;
       SELF.COUNTBOX(X1,Y1,X2,Y2)
       BOX(SELF.X,SELF.Y,SELF.W,SELF.H)

!----------------------------------------------------------------------------------------
!                  
!----------------------------------------------------------------------------------------
SCALEGraf.LINE PROCEDURE(REAL X1,REAL Y1,REAL X2,REAL Y2,<LONG LineColor>)

LOC:SaveColor   LONG
LOC:Omitted     BYTE

 CODE
       LOC:Omitted = OMITTED(6)
       IF ~LOC:Omitted
         LOC:SaveColor = PenColor()
         SetPenColor(LineColor)
       .
       SELF.COUNTBOX(X1,Y1,X2,Y2)
       LINE(SELF.X,SELF.Y,SELF.W,SELF.H)
       IF ~LOC:Omitted
         SetPenColor(LOC:SaveColor)
       .
!----------------------------------------------------------------------------------------
!                  
!----------------------------------------------------------------------------------------
SCALEGraf.FILLRECT PROCEDURE(REAL X1,REAL Y1,REAL X2,REAL Y2,LONG BCOLOR,<LONG LineColor>)

LOC:SaveColor   LONG
LOC:Omitted     BYTE

 CODE
       LOC:Omitted = OMITTED(7)
       IF ~LOC:Omitted
         LOC:SaveColor = PenColor()
         SetPenColor(LineColor)
       .
       SELF.COUNTBOX(X1,Y1,X2,Y2)
       BOX(SELF.X,SELF.Y,SELF.W,SELF.H,BCOLOR)
       IF ~LOC:Omitted
         SetPenColor(LOC:SaveColor)
       .
!----------------------------------------------------------------------------------------
!                   
!----------------------------------------------------------------------------------------
SCALEGraf.PIE PROCEDURE(*SIGNED[] MassData,*LONG[] MassColor,<LONG Depth>,<LONG Whole>,<LONG StartAngle>,LONG LineColor)

LOC:SaveColor        LONG
LOC:OmittedDepth     BYTE
LOC:OmittedWhole     BYTE
LOC:OmittedAngle     BYTE

 CODE
       LOC:OmittedDepth = OMITTED(4)
       LOC:OmittedWhole = OMITTED(5)
       LOC:OmittedAngle = OMITTED(6)
       LOC:SaveColor = PenColor()
       SetPenColor(LineColor)
       IF LOC:OmittedDepth AND LOC:OmittedWhole AND LOC:OmittedAngle
         PIE(SELF.X1,SELF.Y1,SELF.X2-SELF.X1,SELF.Y2-SELF.Y1,MassData,MassColor)
       ELSIF LOC:OmittedDepth AND LOC:OmittedWhole AND ~LOC:OmittedAngle
         PIE(SELF.X1,SELF.Y1,SELF.X2-SELF.X1,SELF.Y2-SELF.Y1,MassData,MassColor,,,StartAngle)
       ELSIF LOC:OmittedDepth AND ~LOC:OmittedWhole AND LOC:OmittedAngle
         PIE(SELF.X1,SELF.Y1,SELF.X2-SELF.X1,SELF.Y2-SELF.Y1,MassData,MassColor,,Whole)
       ELSIF LOC:OmittedDepth AND ~LOC:OmittedWhole AND ~LOC:OmittedAngle
         PIE(SELF.X1,SELF.Y1,SELF.X2-SELF.X1,SELF.Y2-SELF.Y1,MassData,MassColor,,Whole,StartAngle)
       ELSIF ~LOC:OmittedDepth AND LOC:OmittedWhole AND LOC:OmittedAngle
         PIE(SELF.X1,SELF.Y1,SELF.X2-SELF.X1,SELF.Y2-SELF.Y1,MassData,MassColor,Depth)
       ELSIF ~LOC:OmittedDepth AND LOC:OmittedWhole AND ~LOC:OmittedAngle
         PIE(SELF.X1,SELF.Y1,SELF.X2-SELF.X1,SELF.Y2-SELF.Y1,MassData,MassColor,Depth,,StartAngle)
       ELSIF ~LOC:OmittedDepth AND ~LOC:OmittedWhole AND LOC:OmittedAngle
         PIE(SELF.X1,SELF.Y1,SELF.X2-SELF.X1,SELF.Y2-SELF.Y1,MassData,MassColor,Depth,Whole)
       ELSE
         PIE(SELF.X1,SELF.Y1,SELF.X2-SELF.X1,SELF.Y2-SELF.Y1,MassData,MassColor,Depth,Whole,StartAngle)
       .
       SetPenColor(LOC:SaveColor)
!----------------------------------------------------------------------------------------
!                   
!----------------------------------------------------------------------------------------
SCALEGraf.ROUNDRECT PROCEDURE(REAL X1,REAL Y1,REAL X2,REAL Y2,LONG BCOLOR,<LONG LineColor>)

LOC:SaveColor   LONG
LOC:Omitted     BYTE

 CODE
       LOC:Omitted = OMITTED(7)
       IF ~LOC:Omitted
         LOC:SaveColor = PenColor()
         SetPenColor(LineColor)
       .
       SELF.COUNTBOX(X1,Y1,X2,Y2)
       ROUNDBOX(SELF.X,SELF.Y,SELF.W,SELF.H,BCOLOR)
       IF ~LOC:Omitted
         SetPenColor(LOC:SaveColor)
       .
!----------------------------------------------------------------------------------------
!                  
!----------------------------------------------------------------------------------------
SCALEGraf.POLY PROCEDURE(*REAL[] X,LONG MaxInd,LONG BCOLOR,LONG LineColor)

LOC:SaveColor   LONG
LOC:I           LONG
LOC:X           SIGNED,DIM(MaxInd)

 CODE
       LOOP LOC:I = 1 TO MaxInd BY 2
         LOC:X[LOC:I] = SELF.GETX(X[LOC:I]) + SELF.X1
         LOC:X[LOC:I+1] = SELF.GETY(X[LOC:I+1]) + SELF.Y1
       .
       LOC:SaveColor = PenColor()
       SetPenColor(LineColor)
       POLYGON(LOC:X,BCOLOR)
       SetPenColor(LOC:SaveColor)
!----------------------------------------------------------------------------------------
!                  
!----------------------------------------------------------------------------------------
SCALEGraf.ELLIPSE PROCEDURE(REAL X1,REAL Y1,REAL X2,REAL Y2,LONG BCOLOR,LONG LineColor)

LOC:SaveColor   LONG

 CODE
       LOC:SaveColor = PenColor()
       SetPenColor(LineColor)
       SELF.COUNTBOX(X1,Y1,X2,Y2)
       ELLIPSE(SELF.X,SELF.Y,SELF.W,SELF.H,BCOLOR)
       SetPenColor(LOC:SaveColor)
!----------------------------------------------------------------------------------------
!                  
!----------------------------------------------------------------------------------------
SCALEGraf.RECT PROCEDURE(REAL X1,REAL Y1,REAL X2,REAL Y2,<LONG LineColor>)

LOC:SaveColor   LONG
LOC:Omitted     BYTE

 CODE
       LOC:Omitted = OMITTED(6)
       IF ~LOC:Omitted
         LOC:SaveColor = PenColor()
         SetPenColor(LineColor)
       .
       SELF.COUNTBOX(X1,Y1,X2,Y2)
       BOX(SELF.X,SELF.Y,SELF.W,SELF.H)
       IF ~LOC:Omitted
         SetPenColor(LOC:SaveColor)
       .
!----------------------------------------------------------------------------------------
!                  
!----------------------------------------------------------------------------------------
SCALEGraf.ARC PROCEDURE(REAL X1,REAL Y1,REAL X2,REAL Y2,SHORT AStart,SHORT AEnd,LONG LineColor)

LOC:SaveColor   LONG

  CODE

       LOC:SaveColor = PenColor()
       SetPenColor(LineColor)
       SELF.COUNTBOX(X1,Y1,X2,Y2)
       ARC(SELF.X,SELF.Y,SELF.W,SELF.H,AStart,AEnd)
       SetPenColor(LOC:SaveColor)
!----------------------------------------------------------------------------------------
!                  
!----------------------------------------------------------------------------------------
SCALEGraf.CHORD PROCEDURE(REAL X1,REAL Y1,REAL X2,REAL Y2,SHORT AStart,SHORT AEnd,LONG Bcolor,LONG LineColor)

LOC:SaveColor   LONG

  CODE

       LOC:SaveColor = PenColor()
       SetPenColor(LineColor)
       SELF.COUNTBOX(X1,Y1,X2,Y2)
       CHORD(SELF.X,SELF.Y,SELF.W,SELF.H,AStart,AEnd,Bcolor)
       SetPenColor(LOC:SaveColor)
!----------------------------------------------------------------------------------------
!                    
!----------------------------------------------------------------------------------------
SCALEGraf.CLS PROCEDURE
 CODE
       BLANK(SELF.X1-8,SELF.Y1-8,SELF.X2-SELF.X1+16,SELF.Y2-SELF.Y1+16)

!----------------------------------------------------------------------------------------
!                   
!----------------------------------------------------------------------------------------
SCALEGraf.TITLE PROCEDURE(STRING TitleGr)
   CODE

   SHOW(SELF.X1,SELF.Y1-8,TitleGr)                     ! 

!----------------------------------------------------------------------------------------
!                
!----------------------------------------------------------------------------------------
SCALEGraf.DELTA PROCEDURE(REAL DX, REAL DY, LONG ColorDelta)
WX   REAL
WY   REAL
STL  BYTE
SC   SHORT

 CODE
   STL = PenStyle(); SetPenStyle(PEN:Dot)
   SC  = PenColor(); SetPenColor(ColorDelta)

   LOOP WX = SELF.XMIN+DX TO SELF.XMAX-DX BY DX
        SELF.LINE(WX, SELF.YMIN, WX, SELF.YMAX)
   .

   LOOP WY = SELF.YMIN+DY TO SELF.YMAX-DY BY DY
     SELF.LINE(SELF.XMIN, WY, SELF.XMAX,WY)
   .

   SetPenStyle(STL)
   SetPenColor(SC)

!----------------------------------------------------------------------------------------
!                
!----------------------------------------------------------------------------------------
SCALEGraf.GREED PROCEDURE(SHORT NX,SHORT NY, LONG ColorGreed)
WX   REAL
WY   REAL
DX   REAL
DY   REAL
STL  BYTE
SC   SHORT
IND  SHORT

 CODE
   STL = PenStyle(); SetPenStyle(PEN:Dot)
   SC  = PenColor(); SetPenColor(ColorGreed)

   DX = (SELF.XMAX - SELF.XMIN)/NX
   DY = (SELF.YMAX - SELF.YMIN)/NY

   LOOP IND = 1 TO NX - 1
     WX = SELF.XMIN + INd*DX
     SELF.LINE(WX, SELF.YMIN, WX, SELF.YMAX)
   .

   LOOP IND = 1 TO NY - 1
     WY = SELF.YMIN + INd*DY
     SELF.LINE(SELF.XMIN, WY, SELF.XMAX,WY)
   .

   SetPenStyle(STL)
   SetPenColor(SC)


!----------------------------------------------------------------------------------------
!                   Y = F(X)
!----------------------------------------------------------------------------------------
SCALEGraf.TREND PROCEDURE(*REAL [] X, *REAL [] Y,BYTE LinkS , LONG ColTr , BYTE LOC:ShowTitle)

IND SHORT !  
SA  SHORT !   
SC  LONG !   
NSX  REAL  !   
NSY  REAL  !   
LastY     SHORT
CurrentY     SHORT

 CODE
      SC  = PenColor(); SetPenColor(ColTr)  !  

      SA = Maximum(X,1)                     !   

      NSX = ABS(SELF.XMAX - SELF.XMIN)/100   !    
      NSY = ABS(SELF.YMAX - SELF.YMIN)/100   !    

      LOOP IND = 1 TO SA                    !    

           IF LOC:ShowTitle = 1
             IF IND <> SA
               SHOW(SELF.X1 + SELF.GETX(X[IND]),SELF.Y2,CLIP(LEFT(FORMAT(ROUND(X[IND],.01),@n-_10.2))))
             .
             CurrentY = SELF.Y1 + SELF.GETY(Y[IND])
             IF Y[IND] = SELF.YMIN
               CurrentY -= 8
 !              SHOW(SELF.X1+1,SELF.Y1 + SELF.GETY(Y[IND]) - 8,CLIP(LEFT(FORMAT(ROUND(Y[IND],.01),@n-_10.2))))
 !            ELSE
 !              SHOW(SELF.X1+1,SELF.Y1 + SELF.GETY(Y[IND]),CLIP(LEFT(FORMAT(ROUND(Y[IND],.01),@n-_10.2))))
             .
             IF ABS(LastY - CurrentY) > 8
               LastY = CurrentY
               SHOW(SELF.X1+1,CurrentY,CLIP(LEFT(FORMAT(ROUND(Y[IND],.01),@n-_10.2))))
             .
           .

           SELF.PNT(X[IND],Y[IND],NSX,NSY)    !    

           IF LinkS = 1 AND IND > 1 Then    !     
              SELF.LINE(X[IND-1],Y[IND-1],X[IND],Y[IND])
           .
      .

 SetPenColor(SC)                            !   

!----------------------------------------------------------------------------------------
!                  
!----------------------------------------------------------------------------------------
SCALEGraf.VGIST PROCEDURE( *REAL [] Y,SHORT DISCR, LONG ColTr)  !  
MING   REAL             !   
MAXG   REAL             !   
IND    SHORT            !  
WIG    SHORT            !   
DG     REAL             !     
SA     SHORT            !   
SC     SHORT            !   
STATG  LONG, DIM(100)   !  
WCOL   REAL             !   
KScale REAL             !   
KSM    LONG             !     

 CODE
    SC  = PenColor(); SetPenColor(ColTr)        !   

    SA = Maximum(Y,1)                           !   

!    MING = SELF.YMAX; MAXG = SELF.YMIN
    MING = Y[1]; MAXG = Y[1]
    LOOP IND = 1 TO SA
         IF Y[IND] > MAXG THEN MAXG = Y[IND].   !  
         IF Y[IND] < MING THEN MING = Y[IND].   !   
    .

    DG = (MAXG - MING)/DISCR                    !   

    LOOP IND = 1 TO SA                          !   
         WIG = Y[IND]/DG + 1                    !   

         STATG[WIG] += 1                        !    
    .

    KSM = STATG[1]                                   !  
    LOOP IND = 1 TO DISCR                            !    
         IF KSM < STATG[IND] THEN KSM = STATG[IND].
    .

    !--------------------------------------------------------------------------------

    WCOL = (SELF.YMAX - SELF.YMIN)/DISCR
    KScale = (SELF.XMAX - SELF.XMIN)/KSM

    LOOP IND = 1 TO DISCR
         SELF.FILLRECT(0,(IND-1)*WCOL,STATG[IND]*KScale,IND*WCOL,ColTr)
    .

 SetPenColor(SC)                                !   

!----------------------------------------------------------------------------------------
!                  
!----------------------------------------------------------------------------------------
SCALEGraf.HGIST PROCEDURE( *REAL [] Y,SHORT DISCR, LONG ColTr)  !  

MING   REAL             !   
MAXG   REAL             !   
IND    SHORT            !  
WIG    SHORT            !   
DG     REAL             !     
SA     SHORT            !   
SC     SHORT            !   
STATG  LONG, DIM(100)   !  
WCOL   REAL             !   
KScale REAL             !   
KSM    LONG             !     

 CODE
    SC  = PenColor(); SetPenColor(ColTr)        !   

    SA = Maximum(Y,1)                           !   

    MING = Y[1]; MAXG = Y[1]
    LOOP IND = 1 TO SA
         IF Y[IND] > MAXG THEN MAXG = Y[IND].   !  
         IF Y[IND] < MING THEN MING = Y[IND].   !   
    .

    DG = (MAXG - MING)/DISCR                    !   

    LOOP IND = 1 TO SA                          !   
         WIG = Y[IND]/DG + 1                    !   

         STATG[WIG] += 1                        !    
    .

    KSM = STATG[1]                                   !  
    LOOP IND = 1 TO DISCR                            !    
         IF KSM < STATG[IND] THEN KSM = STATG[IND].
    .

    !--------------------------------------------------------------------------------

    WCOL = (SELF.XMAX - SELF.XMIN)/DISCR
    KScale = (SELF.YMAX - SELF.YMIN)/KSM

    LOOP IND = 1 TO DISCR
         SELF.FILLRECT((IND-1)*WCOL,0,IND*WCOL,STATG[IND]*KScale,ColTr)
    .

 SetPenColor(SC)                                !   


!----------------------------------------------------------------------------------------
!              
!----------------------------------------------------------------------------------------
SCALEGraf.HGIST PROCEDURE( *REAL [] Y, LONG ColTr)

SC     SHORT    !   
SA     SHORT    !   
IND    SHORT    !  
WCOL   REAL     !   
WI     REAL     !   
AMAX   REAL     !   
KScale REAL     !  
 CODE

    SA = Maximum(Y,1)                           !   

    AMAX = Y[1]                                 !    
    LOOP IND=2 TO SA
         IF AMAX < Y[IND] THEN AMAX = Y[IND].
    .

    KScale = (SELF.YMAX - SELF.YMIN)/AMAX

    WCOL = (SELF.XMAX - SELF.XMIN)/SA           !   

    SC  = PenColor(); SetPenColor(ColTr)        !   

    LOOP IND = 1 TO SA
         SELF.FILLRECT((IND-1)*WCOL,0,IND*WCOL,Y[IND]*KScale,ColTr)
    .

    SetPenColor(SC)                             !   

!----------------------------------------------------------------------------------------
!              
!----------------------------------------------------------------------------------------
SCALEGraf.VGIST PROCEDURE( *REAL [] Y, LONG ColTr)

SC     SHORT    !   
SA     SHORT    !   
IND    SHORT    !  
WCOL   REAL     !   
WI     REAL     !   
AMAX   REAL     !   
KScale REAL     !  
 CODE

    SA = Maximum(Y,1)                           !   

    AMAX = Y[1]                                 !    
    LOOP IND=2 TO SA
         IF AMAX < Y[IND] THEN AMAX = Y[IND].
    .

    KScale = (SELF.XMAX - SELF.XMIN)/AMAX

    WCOL = (SELF.YMAX - SELF.YMIN)/SA           !   

    SC  = PenColor(); SetPenColor(ColTr)        !   

    LOOP IND = 1 TO SA
         SELF.FILLRECT(0,(IND-1)*WCOL,Y[IND]*KScale,IND*WCOL,ColTr)
    .

    SetPenColor(SC)                             !   

!----------------------------------------------------------------------------------------